%{
#include <stdio.h>
#include <stdlib.h>
#define YYDEBUG 1

extern int yylex();

void yyerror(char* s){
	fprintf(stderr,"%s\n",s);
	exit(EXIT_FAILURE);
}

/* niz promenljivih, za svako slovo jedan element niza */
float promenljive[26];

%}
/* U uniji sada imamo 2 polja. */
%union {
	char ime;
	float vrednost;
}

/* Zadajemo asocijativnost i prioritet operatorima*/
%nonassoc '<' '>' EQ NEQ LEQ GEQ
%left '+' '-'
%left '*' '/'
%left UMINUS

/* Navodimo sve tokene */
%token PRINT EQ NEQ LEQ GEQ
/* Tokenima dodeljujemo odgovarajuca polja unije. */
%token <vrednost>  BROJ
%token <ime> ID 
/* isto to i neterminalima*/
%type <vrednost> e
/* aksioma gramatike*/
%start program

%%
program : program naredba ';'	{}
	| naredba	';'				{}
	;
naredba : PRINT '(' e ')' 	{ printf("%.2f\n",$3); }
	| ID '=' e				{ /* definisemo promenljivu */
								promenljive[$1-'a'] = $3; }
	| e '<' e				{ if ( $1 < $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	| e LEQ e				{ if ( $1 <= $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	| e '>' e				{ if ( $1 > $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	| e GEQ e				{ if ( $1 >= $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	| e EQ e				{ if ( $1 == $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	| e NEQ e				{ if ( $1 != $3)
								printf("Tacno!\n");
							 else 
								printf("Netacno!\n"); }
	;

e	: e '+' e	{ $$ = $1 + $3; }
	| e '-' e	{ $$ = $1 - $3; }
	| e '*' e	{ $$ = $1 * $3; }
	| e '/' e	{ if($3 == 0)
					yyerror("Deljenje nulom\n");
					$$ = $1 / $3; }
	| '(' e ')'	{ $$ = $2; }
	| '-' e	%prec UMINUS	{ $$ = -$2; }
	| BROJ		{ $$ = $1; }
	| ID 		{ /* izraz dobija vrednost promenljive */
					$$ = promenljive[$1-'a'];}
	;

%%

int main(){
/*	yydebug = 1; */
	yyparse();
	return 0;
}