%option noyywrap
%option noinput
%option nounput

%{
#include "y.tab.h"
%}

%%
[<>;=+*()/-]          return *yytext;
[0-9]+(\.[0-9]+)? { yylval.vrednost = atof(yytext); 
                  return BROJ;}  
"!="            return NEQ;
"<="            return LEQ;
">="            return GEQ;
"=="            return EQ;
print               return PRINT;                  
[a-z_A-Z][a-zA-Z_0-9]* {
                      yylval.ime = strdup(yytext); 
                      if(yylval.ime == NULL){
                        fprintf(stderr, "Neuspesna alokacija memorije za ID");
                        exit(EXIT_FAILURE);
                      }
                        
                      
                      return ID;}                  
[ \n]               {}
                  
.   {fprintf(stderr, "Nepoznata leksema: %s\n",yytext);
      exit(EXIT_FAILURE);}
%%