%{
#include <stdio.h>
#include <stdlib.h>
#define YYDEBUG 1

#include "y.tab.h"
#include "stablo.h"

extern int yylex();

int yyerror(char *s){
  fprintf(stderr, "Greska: %s\n",s);
  exit(EXIT_FAILURE);
}

Cvor * promenljive = NULL;

%}

%union{
  float vrednost;
  char *ime; 
}

%token PRINT 

%token<vrednost> BROJ
%token<ime> ID

%type<vrednost> e


%nonassoc '<' '>' EQ NEQ LEQ GEQ
%left '+' '-'
%left '*' '/'
%right UMINUS

%start program
%%
program : program  naredba ';' {}
  | naredba ';'                 {}
  ;
  
naredba :  PRINT e  { printf("%f\n", $2); }
  | ID '=' e         { dodaj(&promenljive, $1, $3 );
  
  }
  | e '<' e           { printf("%s\n",( $1< $3 ? "True": "False" ));
    }
  | e '>' e         {printf("%s\n",( $1 > $3 ? "True": "False" ));}
  | e EQ  e         { printf("%s\n",( $1 == $3 ? "True": "False" ));}
  | e NEQ e         { printf("%s\n",( $1 != $3 ? "True": "False" ));}
  | e LEQ e         {printf("%s\n",( $1 <= $3 ? "True": "False" ));}
  | e GEQ e         {printf("%s\n",( $1 >= $3 ? "True": "False" ));}
  ;

e : e '+' e     {$$ = $1 + $3;}
  | e '-' e     { $$ = $1 - $3; }
  | e '*' e     {$$ = $1  * $3;}
  | e '/' e     { if($3 == 0)
                    yyerror("Deljenje nulom!\n");
                  $$ = $1 / $3; }
  | '-' e  %prec UMINUS     { $$ = -$2; }
  | '(' e ')'   { $$ = $2; }
  | BROJ        { $$ = $1; }   
  | ID          { Cvor* nadjen;
                  if( (nadjen = nadji(promenljive, $1)) == NULL )
                    yyerror("Nedefinisana promenljiva!");
                
                  $$ = nadjen->vrednost;
                  free($1);
                }
  ;
  

%%

int main(){
  yydebug = 0;

  yyparse();
  
  oslobadi_stablo(&promenljive);
  
  return 0;
}